# ----------------------------------------------------------------------------
# 保護檔案目錄
# ----------------------------------------------------------------------------
Options +SymLinksIfOwnerMatch +ExecCGI +Includes +IncludesNOEXEC -Indexes

# ----------------------------------------------------------------------------
# 保護 .htaccess
# ----------------------------------------------------------------------------
<files ~ "^.*\.([Hh][Tt][Aa])">
order allow,deny
deny from all
satisfy all
</files>

# ----------------------------------------------------------------------------
# 開啟cache相關檔案,加快開啟速度
# ----------------------------------------------------------------------------
<IfModule mod_headers.c>
    <FilesMatch ".(ico|pdf|flv|jpg|jpeg|svg|png|gif|js|css|swf|gz)$">
        Header set Cache-Control "max-age=604800, public"
    </FilesMatch>
</IfModule>

# 301 Redirect /public/builder/ /cms/dashboard/get_template/

<IfModule mod_expires.c>
    ExpiresActive On
    ExpiresByType image/jpg "access 1 year"
    ExpiresByType image/jpeg "access 1 year"
    ExpiresByType image/gif "access 1 year"
    ExpiresByType image/png "access 1 year"
    ExpiresByType image/svg "access 1 year"
    ExpiresByType text/css "access 1 month"
    ExpiresByType application/pdf "access 1 month"
    ExpiresByType text/x-javascript "access 1 month"
    ExpiresByType application/x-shockwave-flash "access 1 month"
    ExpiresByType image/x-icon "access 1 year"
    ExpiresDefault "access 2 days"
</IfModule>

# ----------------------------------------------------------------------------
# 開啟伺服器Gzip壓縮
# ----------------------------------------------------------------------------
<IfModule mod_deflate.c> 
    AddOutputFilterByType DEFLATE text/html text/plain text/xml text/css application/javascript application/x-javascript application/xml application/xhtml+xml application/rss+xml 
</IfModule>

# ----------------------------------------------------------------------------
# Codeigniter_省掉index.php
# ----------------------------------------------------------------------------
#<IfModule mod_rewrite.c>
#    DirectoryIndex index.php
#    RewriteEngine on
#    RewriteCond $1 !^(index\.html|php|images|css|js|img|robots\.txt|favicon\.ico)
#    RewriteCond %{REQUEST_FILENAME} !-f
#    RewriteCond %{REQUEST_FILENAME} !-d
#    RewriteCond %{REQUEST_URI} !^/\.well-known/cpanel-dcv/[0-9a-zA-Z_-]+$
#    RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/(?:\ Ballot169)?
#    RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/[A-F0-9]{32}\.txt(?:\ Sectigo\ DCV)?$
#    RewriteRule ^(.*)$ ./index.php?/$1 [L,QSA]
#</IfModule>

# Redirect 301 /shun/speedmatchv2/theme/ /shun/speedmatchv2/theme/index

# ----------------------------------------------------------------------------
# Http to Https
# ----------------------------------------------------------------------------
<IfModule mod_rewrite.c>
    RewriteEngine On
    RewriteCond %{SERVER_PORT} !^443$
    RewriteCond %{REQUEST_URI} !^/\.well-known/cpanel-dcv/[0-9a-zA-Z_-]+$
    RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/(?:\ Ballot169)?
    RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/[A-F0-9]{32}\.txt(?:\ Sectigo\ DCV)?$
    RewriteRule ^(.*)$ https://%{HTTP_HOST}%{REQUEST_URI} [L,R=301]
</IfModule>  

# ----------------------------------------------------------------------------
# 防止駭客
# ----------------------------------------------------------------------------  

# 阻止腳本通過URL傳遞的base64_encode垃圾信息  
RewriteCond %{QUERY_STRING} base64_encode.*(.*) [OR]  

# 阻止在URL含有<script>標記的腳本  
RewriteCond %{QUERY_STRING} (<|%3C).*script.*(>|%3E) [NC,OR]  

# 阻止企圖通過URL設置PHP的GLOBALS變量的腳本  
RewriteCond %{QUERY_STRING} GLOBALS(=|[|%[0-9A-Z]{0,2}) [OR]  

# 阻止企圖通過URL設置PHP的_REQUEST變量的腳本  
RewriteCond %{QUERY_STRING} _REQUEST(=|[|%[0-9A-Z]{0,2})  

# 把所有被阻止的請求轉向到403禁止提示頁面！  
RewriteCond %{REQUEST_URI} !^/\.well-known/cpanel-dcv/[0-9a-zA-Z_-]+$
RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/(?:\ Ballot169)?
RewriteCond %{REQUEST_URI} !^/\.well-known/pki-validation/[A-F0-9]{32}\.txt(?:\ Sectigo\ DCV)?$
RewriteRule ^(.*)$ index.php [F,L]  
